Index: psi/trunk/Changes.txt
===================================================================
--- psi/trunk/Changes.txt	(revision 73)
+++ psi/trunk/Changes.txt	(revision 73)
@@ -0,0 +1,130 @@
+List of Changes
+---------------
+
+Note 1: Items marked as [<plarform>] are specific to the given platform only.
+Note 2: Items marked as [Qt ...] are applied to the Qt Toolkit, not to Psi.
+
+
+Version 0.10-os2-b2 (2006-09-25)
+--------------------------------
+
+Improvements:
+    
+    - [OS/2] Built using Qt 3.3.1-RC7 SVN build r131.
+
+    - [OS/2] Implemented the OS/2 version of the QCA SSL plugin (qca-tls.dll)
+      that brings the SSL connection support to Psi. When using the
+      WarpIn package, the plugin installation is optional.
+
+    - [OS/2] Added support for the Innotek Font Engine. If it is installed,
+      Psi will start using it automatically (i.e. will anti-alias all vector
+      fonts).
+      
+    - [OS/2] Added recognition of the "PM Default Browser/Mail" setting for
+      opening links. See "Manual Installation" for more info.
+
+    - [OS/2] If the "Raise chat window on receiving new messages" option is
+      selected, but the chat window is on an invisible XPager page, it will be
+      moved to the current (visible) one.
+
+    - Pressing ESC in a chat or a group chat window minimizes it instead of
+      closing. You can close the window using Ctrl-W or Alt-F4, as before.
+
+    - Changed the !beep sound functionality (recognized when assigning
+      sound files to events): the new format is !beep[:freq[,dur]]... that
+      allows to assign different "beep" sound sequences (simple melodies)
+      to events instead of Wave files [OS/2 & Win32 only].
+  
+Fixed Bugs:
+
+    - [OS/2] Psi could trap with SY3184 (divide-by-zero) on systems with
+      DBCS codepages (e.g. Japanese OS/2) [Qt bug].
+
+    - [OS/2] Added a workaround for single-streamed sound cards (e.g. ESS688)
+      with badly written drivers: playing too many sounds simultaneously
+      on such a card in the shared mode can cause 100% CPU load followed by a UI
+      hang. Set the QT_PM_NO_SOUND_SHARE environment variable to a non-empty
+      value (e.g. YES) in order to tell Qt open sound devices in the exclusive
+      mode [Qt enancement].
+
+    - [OS/2] Running Psi for a long time could waste PM timer resources and
+      cause other applications to behave badly (e.g. stopped icon/image
+      animation in PMMail/EFCommander, frozen UI in PMDownloader, etc.)
+      [Qt regression].
+    
+    - [OS/2] Psi would silently crash if the HOME environment variable was not
+      set or pointed to a wrong (non-existing) location [Qt bug].
+
+    - When the "Raise chat window on receiving new messages" (or the "Raise
+      Roster Window On New Event") option was set, the chat (or the roster)
+      window also took the keyboard focus instead of just bringing itself to
+      front.
+      
+    - When the "Open chats in tabbed mode" option was in action, the
+      confirnation dialog appearing when the chat window is to be closed
+      rapidly after receiving a new event, was ignored.
+      
+    - [Win32] The "Raise window..." function didn't actually put the
+      relevant window on top of the currently active window.      
+
+
+Version 0.10-os2-b1 (2006-08-18)
+--------------------------------
+
+Improvements:
+
+    - [OS/2] Built using Qt 3.3.1-RC7 SVN build r118.
+
+    - Chat tabs can be switched using Ctrl+Tab and Ctrl+Shift+Tab
+      combinations (together with cross-platform Ctrl+PgUp/Ctrl+PgDn).
+
+    - Pressing the Esc key in the Roster window minimizes it if the Docklet
+      widget (tray icon) is disabled (which is always true on OS/2 since there
+      is no xCenter/SysTray integration yet).
+
+    - [OS/2] Removed the Options->Sound->Player entry field (not used in OS/2).
+
+Fixed Bugs:
+
+    - [OS/2] Unpainted vertical strip in QToolBar (seen to the left from the
+      Clear chat window button) [Qt bug].
+
+    - [OS/2] Pressing AltGr+key could produce valid characters in some
+      keyboard layouts (i.e. the German one) which were ignored in the chat
+      window [Qt bug].
+
+    - [OS/2] In the roster: pressing the Status button right after pressing
+      the Psi button didn't unpress the latter (and vice versa) [Qt bug].
+
+    - [OS/2] Notification popups didn't take the desktop work area size into
+      account (appeared over the xCenter widget) [Qt enhancement].
+
+    - [OS/2] Playing too many sounds simultaneously could screw up a
+      single-streamed audio driver and cause the application hang during
+      termination or even a crash [Qt improvement].
+
+    - [OS/2] All network activity (including file transfer) was suspended
+      during moving or resizing Psi windows using the mouse [Qt improvement].
+
+    - [OS/2] Selecting 'Rerequest authorization from' in the context menu
+      of ICQ and Transport contacts in the Roster would crash Psi.
+
+    - [OS/2] Opening the chat window could sometimes crash Psi (SIGFPE)
+      [Qt bug].
+
+    - When both "Open chats in tabbed mode" and "Raise chat window on receiving
+      new messages" were set, receiving a new message would bring the chat
+      window to front but would not change the active tab to the one
+      corresponding to the chat window.
+
+    - [OS/2] Closing Psi trying to connect (resolve the server name) when
+      there was no Internet connection hid all Psi windows but didn't exit
+      the process until the request timed out (that could take quite a
+      long and didn't allow to start another Psi instance).
+
+
+Version 0.10-os2-a1 (2006-07-25)
+--------------------------------
+    
+    The first public alpha version (built using Qt 3.3.1-RC7 SVN build r102).
+
Index: psi/trunk/Readme-OS2.txt
===================================================================
--- psi/trunk/Readme-OS2.txt	(revision 68)
+++ psi/trunk/Readme-OS2.txt	(revision 73)
@@ -1,25 +1,23 @@
-Psi 0.10-os2-b1 (Beta 1)
-------------------------
-Date: August 18th, 2006
+Psi for OS/2
+------------
+
+This file contains information specific to the OS/2 version of Psi.
+Before reading it, please refer to the Readme.txt file that contains
+general information about Psi.
+
+For a list of changes, see the Changes.txt file.
 
 
-OS/2 Port Creator/Maintainer:
-    Dmitry A. Kuminov
-    dmik-qt(at)hugaida.com
-    http://svn.netlabs.org/qt3/ticket/25
+Requirements
+------------
 
-Using Qt Toolkit Version 3 for OS/2:
-    Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
-    Copyright (C) 2004 Norman ASA.  Initial OS/2 Port.
-    Copyright (C) 2005-2006 netlabs.org.  Further OS/2 Development.
-    Ported to OS/2 by Dmitry A. Kuminov
-    http://svn.netlabs.org/qt3
-
-
-This readme contains information specific to the OS/2 version of Psi.
-For general information, please refer to Readme.txt, Install.txt and
-to the online documentation you can find at http://psi-im.org/.
-
-For the list of changes, see the bottom of this file. 
+1.  Make sure kLIBC 0.6.1 library (libc061.dll) is installed on your system.
+    If not, download it from ftp://ftp.netlabs.org/pub/gcc/libc-0.6.1-csd1.zip
+    and unzip the archive to a directory you plan to install Psi to or to one
+    of the directories listed in your LIBPATH environment variable.
+    
+2.  (Optional) If you want to use anti-aliased fonts in Psi, download and
+    install the InnoTek Font Engine for OS/2.  The direct download link is
+    http://download.innotek.de/ft2lib/InnoTek_FT2LIB_260_Beta1.exe
 
 
@@ -27,23 +25,79 @@
 -------------------
 
-1.  Make sure Innotek (Bird) LIBC 0.6.1 library (libc061.dll) is
-    installed on your system. Download the library from
-    ftp://ftp.netlabs.org/pub/gcc/libc-0.6.1-csd1.zip and unzip
-    the archive to the directory you plan to install Psi to or to
-    one of the directories listed in your LIBPATH environment variable.
+1.  Unzip the Psi archive containing this file to a directory of your
+    choice and run the Psi executable (psi.exe).
+    
+2.  Additionally, you can download a Language Pack for your language using
+    the following link: http://psi-im.org/download.  Follow the on-site
+    instructions in order to install it.
 
-2.  Unzip the Psi archive containing this file to the directory of your
-    choice and run the Psi executable (psi.exe). No additional
-    installation is required.
+3.  If you want to use the "PM Default Browser/Mail" setting to open links
+    within chat windows, make sure that you have the default PM broser and
+    mail client applications set up correctly.  The easiest way to do this is
+    to use the "Configure Internet Applications" tool from Hobbes
+    (http://hobbes.nmsu.edu/pub/os2/apps/misc/configapps1_1_1.zip).
+
+Please refer to the Trobuleshooting section below for additional information
+on how to resolve problems you may encounter when running Psi for OS/2.
 
 
-Configuration data
+Upgrading to a New Vesion
+-------------------------
+
+If you are upgrading your installation from a previous version of Psi, please
+always use a clean directory to install the new version to avoid possible file
+conflicts.
+
+Please note that installing a new version to a clean directory will not affect
+your existing personal configuration data (Psi profiles, account settings,
+message history) because it is stored in a separate directory and therefore
+will be preserved.  It is however recommended to make a backup copy of all
+configuration data before starting a new version of Psi for the first time
+(to protect from accidential data loss due to possible changes in formats of
+configuration files).  Refer to the section called "Configuration Data" for
+more details about where this data is stored.
+
+Note that if you want to run two different versions of Psi simultaneously
+(in general, there is no such a need, but just to let you know), you will have
+to create and use a .CMD script that sets the following environment variables
+prior to starting the Psi executable:
+
+    set BEGINLIBPATH=<path_to_Psi_exe>
+    set LIBPATHSTRICT=T
+
+
+Configuration Data
 ------------------
 
-Psi stores all configuration files in the subdirectory /PsiData of
-your home directory (pointed to by the HOME environment variable).
+Psi stores all configuration files (such as Psi profiles, account settings,
+message history, etc.) in the subdirectory /PsiData of your home directory
+(pointed to by the HOME environment variable).  Note that if the HOME variable
+is invalid or points to a non-existing location, the /PsiData subdirectory
+will be created in the root directory of the boot drive.
 
-The name of the last used Psi profile is stored in the registry
+The name of the last used Psi profile is stored in the Open32 Registry
 under the key HKEY_CURRENT_USER\Software\Affinix\psi.
+
+The paths and parameters to the default PM browser and mail client applications
+are taken from the HINI_USER_PROFILE\WPURLDEFAULTSETTINGS registry key (stored
+in the X:\OS2\OS2.INI file).
+
+
+Troubleshooting
+---------------
+
+This section describes known problems you may encounter when running
+Psi for OS/2, together with possible solutions.
+
+1.  If you have a single-streamed sound card (a card that cannot play
+    more than one sound at a time) and experience problems with sound
+    in Psi (such as 100% CPU load when playing too many sounds
+    simultaneously), try to add the following line to CONFIG.SYS
+    (or to the .CMD script that starts Psi):
+
+        SET QT_PM_NO_SOUND_SHARE=YES
+
+    This will tell the Qt library to open sound devices in the
+    exclusive mode.
 
 
@@ -51,116 +105,29 @@
 ----------------------------------
 
-1.  Using the PM Default Browser/Mail choice for opening links doesn't
-    work yet. The Custom browser setting requires a command like
-    'cmd /c cd D:\Apps\Firefox & D:\Apps\Firefox\Firefox.exe'.
-    
-2.  SSL connection is completely untested and will most likely not work.
+1.  PGP encryption is completely untested and probably will not work.
 
-3.  PGP encryption is completely untested and probably will not work.
+2.  The global hot keys are not available.
 
-4.  The global hot keys are not available. 
- 
-5.  Idle (i.e. Auto-Away) detection may not work properly.
+3.  Idle (i.e. Auto-Away) detection is only sensitive to mouse movements,
+    meaning that Psi will go away if the mouse is not moved durng the specified
+    amount of time, regardless of whether one presses something on the keyboard
+    or not.  Likewise, using the keyboard will not cancel the Auto-Away state.
 
-6.  The directory watcher service is not available (though I don't yet know
-    what is it good for in Psi). 
+4.  The directory watcher service is not available (affects PGP encryption
+    support).
 
-7.  There is no "tray icon" (xCenter widget) for Psi. It will be available
+5.  There is no "tray icon" (xCenter widget) for Psi. It will be available
     later.
     
-8.  Power management events such as "sleep" or "wakeup" are not detected by Psi.
+6.  Power management events such as "sleep" or "wakeup" are not detected by Psi.
 
-9.  Drag and Drop support in Qt/OS2 is not yet finished, so there are few
+7.  Drag and Drop support in Qt/OS2 is not yet finished, so there are few
     known issues (for example, text in entry fields may be corrupted when the
     drag object is moved over them).
 
-10. The "Roaster window always on top" option is temporarily removed from the
+8.  The "Roster window always on top" option is temporarily removed from the
     options dialog because this functionality is not yet available in Qt/OS2.
 
+9.  DBCS characters can neither be entered nor displayed correctly
+    (current Qt limitation).
 
-Bug Reports
------------
-
-To submit a bug report, please visit http://svn.netlabs.org/qt3/ticket/25
-and add a comment describing the problem.
-
-Note that in order to add a comment, you'll need to login to the Trac system
-using the special name and the password presented on the start page
-(http://svn.netlabs.org/qt3/wiki).  
-
-
-Contributors
-------------
-
-Thanks to the following people who contributed to Psi/2:
-
-Ivan Smirnoff
-    www.sampo.ru/~bigvic 
-	OS/2 icon
-
-Juergen Ulbts
-    WarpIn scripts
-
-
-Changes
--------
-
-Note: fixes marked as [Qt ...] are applied to the Qt library for OS/2,
-not to Psi itself.
-
-*   Version 0.10-os2-b1 (2006-08-18)
-    --------------------------------
-
-    - Built using Qt 3.3.1-RC7 SVN build r118.
-
-    - New: Chat tabs can be switched using Ctrl+Tab and Ctrl+Shift+Tab
-      combinations (together with cross-platform Ctrl+PgUp/Ctrl+PgDn).
-
-    - New: Pressing the Esc key in the Roster window minimizes it
-      if the Doclet widget (tray icon) is disabled (which is always true
-      on OS/2 since there is no xCenter/SysTray integration yet).
-
-    - Fixed: Removed the Options->Sound->Player entry field (not used in
-      OS/2).
-
-    - Fixed: Unpainted vertical strip in QToolBar (seen to the left from the
-      Clear chat window button) [Qt bug].
-
-    - Fixed: Pressing AltGr+key could produce valid characters in some
-      keyboard layouts (i.e. the German one) which were ignored in the chat
-      window [Qt bug].
-
-    - Fixed: In the roster: pressing the Status button right after pressing
-      the Psi button didn't unpress the latter (and vice versa) [Qt bug].
-
-    - Fixed: Notification popups didn't take the desktop work area size into
-      account (appeared over the xCenter widget) [Qt enhancement].
-
-    - Fixed: Playing too many sounds simultaneously could screw up a
-      single-streamed audio driver and cause the application hang during
-      termination or even a crash [Qt improvement].
-
-    - Fixed: All network activity (including file transfer) was suspended
-      during moving or resizing Psi windows using the mouse [Qt improvement].
-
-    - Fixed: Selecting 'Rerequest authorization from' in the context menu
-      of ICQ and Transport contacts in the Roster would crash Psi.
-
-    - Fixed: Opening the chat window could sometimes crash Psi (SIGFPE)
-      [Qt bug].
-
-    - Fixed: When both "Open chats in tabbed mode" and "Raise chat window on
-      receiving new messages" were set, receiving a new message would bring
-      the chat window to front but would not change the active tab to the one
-      corresponding to the chat window.
-
-    - Fixed: Closing Psi trying to connect (resolve the server name) when
-      there was no Internet connection hid all Psi windows but didn't exit
-      the process until the request timed out (that could take quite a
-      long and didn't allow to start another Psi instance).
-
-
-*   Version 0.10-os2-a1 (2006-07-25)
-    --------------------------------
-    
-    The first public alpha version.
Index: psi/trunk/Readme.txt
===================================================================
--- psi/trunk/Readme.txt	(revision 73)
+++ psi/trunk/Readme.txt	(revision 73)
@@ -0,0 +1,136 @@
+Psi 0.10-os2-b2 (Beta 2)
+------------------------
+Date: September 25th, 2006
+
+
+What is Psi
+-----------
+
+Psi is a capable Jabber client aimed at experienced users.  Its design
+goals are simplicity and stability.  Psi is highly portable and runs on
+Windows, OS/2, Unix/X11, and MacOS X.
+
+The interface is very ICQ-like.  Alerts appear in the contact list when
+events are received, and things like subscriptions requests appear as
+"system messages" (ICQ users know these well).  Even "Chats" are
+queued in the contact list.  Also, chats are "remembered" by default,
+so that you don't have to keep a bunch of windows open for each person.
+Just close the chat window.  If you open it again it will all be there.
+
+Psi is minimal but powerful.  There are keybindings for just about
+everything, Unicode is supported throughout, and contacts are cached
+offline.  Security is also a major consideration, and Psi provides it for
+both client-to-server (SSL) and client-to-client (GnuPG).
+
+You can find more information about Psi on the official Psi home page
+at http://psi-im.org.  
+
+This program is licensed under the GNU General Public License.  See
+the COPYING file inlcuded in this package for more information.
+
+
+What is Psi/2
+-------------
+
+Psi/2 is a separate development branch of Psi initially created to work on
+a version of Psi for OS/2 and eComStation operating systems.  Why a separate
+branch?  In ealy 2006, original Psi authors decided to discontinue the support
+of the Qt Toolkit Version 3 and ported Psi sources to Qt Version 4.  Psi 0.10
+was the last release based on Qt Version 3.  However, Qt Version 4 is not (yet)
+available for the OS/2 platform, therefore the sources of Psi 0.10 have been
+taken and ported to OS/2.
+
+In the process of porting, several minor Psi bugs were fixed and some few
+bits of new functionality were added.  These changes are unlikely to be applied
+to the current official Psi sources because of the differences in Qt Toolkits
+and because original authors are not interested in supporting the Qt 3 branch.
+
+There are some more improvements planned to the Psi/2 branch.  This branch will
+exist until at least Qt Version 4 for OS/2 becomes available.  Please note that
+Psi/2 is NOT supported by original Psi developers, so don't send them bug
+reports and feature requests.  See below for information about reporting bugs.
+
+In order to clearly distinguish the original Psi application from Psi/2,
+the Psi/2 branch has the 'os2' suffix in the Psi version number.  This
+guarantees that version numbers of these two applications will never overlap.
+Note that the application name remains the same (Psi/2 is just a code name for
+the 'os2' branch).
+
+Currently, binary Psi/2 packages are distributed only for OS/2 and eComStation.
+(a Windows package is planned soon).  If you need a version of Psi for a
+different platform, please visit the official Psi home hage mentioned above.
+
+The Psi/2 home page is located at http://svn.netlabs.org/qtapps/wiki/Psi.
+
+Binary Psi/2 packages can be found at ftp://ftp.netlabs.org/pub/qtapps/psi.
+
+
+Installation
+------------
+
+For installation instructions and other platform-specific details, see the
+Readme-OS2.txt file included in this package.
+
+For a list of changes, see the included Changes.txt file.
+
+
+Bug Reports
+-----------
+
+To submit a bug report, please visit the Psi/2 home page at
+http://svn.netlabs.org/qtapps/wiki/Psi and create a ticket describing the
+problem.
+
+Note that in order to create tickets or add comments to existing ones, you will
+need to login to the Trac system using a special name and a password specified
+on the start page (http://svn.netlabs.org/qtapps/).
+
+
+Original Psi Authors
+--------------------
+
+Thanks to these people for creating one of the best Jabber clients:
+
+Project Lead/Maintainer (2004-current):
+    Kevin Smith
+    kismith@psi-im.org
+    http://www.kismith.co.uk/
+
+Original Author (2001-2004):
+    Justin Karneges
+    justin@affinix.com
+    http://psi-im.org/
+
+
+Credits
+-------
+
+Thanks to the following people for contributing to the Psi/2 project:
+
+Ivan Smirnoff
+    www.sampo.ru/~bigvic 
+    OS/2 icon
+
+Juergen Ulbts
+    http://www.juergen-ulbts.de
+    Initial WarpIn scripts
+
+
+Psi/2 Authors
+-------------
+
+Project Maintainer:
+    Dmitry A. Kuminov
+    E-Mail: user 'dmik-qt' at domain 'hugaida.com'
+
+
+Copyrights
+----------
+    
+Qt Toolkit Version 3 for OS/2:
+    Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
+    Copyright (C) 2004 Norman ASA.  Initial OS/2 Port.
+    Copyright (C) 2005-2006 netlabs.org.  Further OS/2 Development.
+    Ported to OS/2 by Dmitry A. Kuminov
+    http://svn.netlabs.org/qt3
+