Index: /trunk/openjdk/jdk/make/com/sun/tools/attach/Exportedfiles.gmk
===================================================================
--- /trunk/openjdk/jdk/make/com/sun/tools/attach/Exportedfiles.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/com/sun/tools/attach/Exportedfiles.gmk	(revision 74)
@@ -28,5 +28,5 @@
 #
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2,$(PLATFORM)),)
 FILES_export = \
         sun/tools/attach/WindowsAttachProvider.java \
Index: /trunk/openjdk/jdk/make/com/sun/tools/attach/FILES_c.gmk
===================================================================
--- /trunk/openjdk/jdk/make/com/sun/tools/attach/FILES_c.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/com/sun/tools/attach/FILES_c.gmk	(revision 74)
@@ -24,5 +24,5 @@
 #
 
-ifeq ($(PLATFORM),windows)
+ifeq ($(filter-out windows os2,$(PLATFORM)),)
 FILES_c = \
         WindowsAttachProvider.c \
Index: /trunk/openjdk/jdk/make/java/awt/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/awt/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/awt/Makefile	(revision 74)
@@ -69,5 +69,5 @@
 CURSORDIR     = $(LIBDIR)/images/cursors
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 CURSORPROPSRC = $(TOPDIR)/src/windows/lib/images/cursors
 CURSORS   = $(CURSORDIR)/win32_CopyDrop32x32.gif      \
Index: /trunk/openjdk/jdk/make/java/java/Exportedfiles.gmk
===================================================================
--- /trunk/openjdk/jdk/make/java/java/Exportedfiles.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/java/java/Exportedfiles.gmk	(revision 74)
@@ -27,5 +27,5 @@
 # These are the names of JAVA classes for which we will make .h files.
 #
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
 FILES_export = \
     java/lang/Object.java \
Index: /trunk/openjdk/jdk/make/java/java_hprof_demo/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/java_hprof_demo/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/java_hprof_demo/Makefile	(revision 74)
@@ -81,5 +81,5 @@
 	         -I$(SHARE_SRC)/demo/jvmti/java_crw_demo
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS += wsock32.lib winmm.lib
 else
Index: /trunk/openjdk/jdk/make/java/main/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/main/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/main/Makefile	(revision 74)
@@ -32,5 +32,5 @@
 include $(BUILDDIR)/common/Defs.gmk
 
-ifeq ($(PLATFORM), windows) 
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
 SUBDIRS = java javaw
 else 
Index: /trunk/openjdk/jdk/make/java/management/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/management/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/management/Makefile	(revision 74)
@@ -53,5 +53,5 @@
 include Exportedfiles.gmk
 
-ifeq ($(PLATFORM),windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
 
 FILES_c     +=  OperatingSystem_md.c
@@ -86,5 +86,5 @@
   -I$(SHARE_SRC)/native/sun/management 
 
-ifeq ($(PLATFORM),windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
   OTHER_LDLIBS += $(JVMLIB)
 endif
Index: /trunk/openjdk/jdk/make/java/net/FILES_c.gmk
===================================================================
--- /trunk/openjdk/jdk/make/java/net/FILES_c.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/java/net/FILES_c.gmk	(revision 74)
@@ -44,5 +44,5 @@
 endif
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
     FILES_c += TwoStacksPlainSocketImpl.c
     FILES_c += DualStackPlainSocketImpl.c
Index: /trunk/openjdk/jdk/make/java/net/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/net/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/net/Makefile	(revision 74)
@@ -37,5 +37,5 @@
 AUTO_FILES_JAVA_DIRS = java/net
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
     # Windows 9x module only needed on 32-bit build
     ifeq ($(ARCH_DATA_MODEL), 32)
@@ -72,5 +72,5 @@
     sun/net/spi/DefaultProxySelector.java
 
-ifeq ($(PLATFORM), windows) 
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
     FILES_export += java/net/TwoStacksPlainSocketImpl.java
     FILES_export += java/net/DualStackPlainSocketImpl.java
@@ -93,5 +93,5 @@
 include $(BUILDDIR)/common/Library.gmk
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
   OTHER_LDLIBS = ws2_32.lib $(JVMLIB)
   # Will not compile at warning level 3 if warnings are fatal
Index: /trunk/openjdk/jdk/make/java/nio/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/nio/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/java/nio/Makefile	(revision 74)
@@ -71,5 +71,5 @@
 endif # PLATFORM = solaris
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),) 
 FILES_java += \
         sun/nio/ch/WindowsSelectorImpl.java \
@@ -81,5 +81,5 @@
 FILES_export += \
 	sun/nio/ch/WindowsSelectorImpl.java
-endif # PLATFORM = windows
+endif # PLATFORM = windows or os2
 
 ifeq ($(PLATFORM), linux)
@@ -130,4 +130,11 @@
   OTHER_LDLIBS += $(JVMLIB) ws2_32.lib \
      -libpath:$(LIBDIR) java.lib \
+     $(OBJDIR)/../../../../sun/java.net/net/$(OBJDIRNAME)/net.lib \
+     $(OBJDIR)/../../../java.lang/java/$(OBJDIRNAME)/io_util.obj \
+     $(OBJDIR)/../../../java.lang/java/$(OBJDIRNAME)/FileDescriptor_md.obj
+endif
+ifeq ($(PLATFORM),os2)
+  OTHER_LDLIBS += $(JVMLIB) ws2_32.lib \
+     -L$(LIBDIR) java.lib \
      $(OBJDIR)/../../../../sun/java.net/net/$(OBJDIRNAME)/net.lib \
      $(OBJDIR)/../../../java.lang/java/$(OBJDIRNAME)/io_util.obj \
Index: /trunk/openjdk/jdk/make/javax/swing/plaf/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/javax/swing/plaf/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/javax/swing/plaf/Makefile	(revision 74)
@@ -39,6 +39,6 @@
 AUTO_FILES_JAVA_DIRS = javax/swing/plaf sun/swing com/sun/java/swing/plaf
 
-ifeq ($(PLATFORM), windows)
-    # Don't build GTK L&F on Windows
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
+    # Don't build GTK L&F on Windows or OS/2
     AUTO_JAVA_PRUNE = gtk
 endif
@@ -49,5 +49,5 @@
 
 MISC_FILES = $(MISC_SWING_FILES)
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
     # Only include GTK icons on Solaris/Linux
     MISC_FILES += $(MISC_SWING_FILES_UNIX)
@@ -70,5 +70,5 @@
 	com/sun/java/swing/plaf/motif/resources/motif.properties \
         com/sun/java/swing/plaf/windows/resources/windows.properties
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
     # Only compile GTK resource bundles on Solaris/Linux
     RESOURCE_BUNDLES_COMPILED_PROPERTIES += \
Index: /trunk/openjdk/jdk/make/jpda/back/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/jpda/back/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/jpda/back/Makefile	(revision 74)
@@ -49,5 +49,5 @@
                  -I$(GENNATIVESRCDIR)/jdwp
 
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS += -ldl
 endif # PLATFORM
@@ -119,5 +119,5 @@
 # Add to ambient vpath so we pick up the library files
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 vpath %.c $(SHARE_SRC)/back:$(SHARE_SRC)/back
 endif # PLATFORM
Index: /trunk/openjdk/jdk/make/launchers/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/launchers/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/launchers/Makefile	(revision 74)
@@ -44,5 +44,5 @@
 
 # Run MAKE $@ for all launchers
-ifeq ($(PLATFORM),windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 # Run MAKE $@ for all platform specific launchers
 define make-platform-specific-launchers
Index: /trunk/openjdk/jdk/make/launchers/Makefile.launcher
===================================================================
--- /trunk/openjdk/jdk/make/launchers/Makefile.launcher	(revision 73)
+++ /trunk/openjdk/jdk/make/launchers/Makefile.launcher	(revision 74)
@@ -142,5 +142,5 @@
   JCONSOLE_CLASSPATH = { "/lib/jconsole.jar", "/lib/tools.jar", "/classes" }
   OTHER_CPPFLAGS += -DAPP_CLASSPATH='$(JCONSOLE_CLASSPATH)'
-  ifeq ($(PLATFORM), windows)
+  ifeq ($(filter-out windows os2, $(PLATFORM)),)
     OTHER_CPPFLAGS += -DJAVAW
     LDLIBS_COMMON  += user32.lib
@@ -151,5 +151,5 @@
 # GUI tools
 ifeq ($(GUI_TOOL),true)
-  ifneq ($(PLATFORM), windows)
+  ifeq ($(filter-out windows os2, $(PLATFORM)),)
     # Anything with a GUI needs X11 to be linked in.
     OTHER_LDLIBS += -L$(OPENWIN_LIB) -lX11
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile	(revision 74)
@@ -36,5 +36,5 @@
 DEMO_OBJECTS    = java_crw_demo.$(OBJECT_SUFFIX)
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   EXTRA_LIBS += wsock32.lib winmm.lib
 endif
Index: /trunk/openjdk/jdk/make/sun/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/Makefile	(revision 74)
@@ -39,5 +39,5 @@
 
 # Non windows subdirs
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   ifndef OPENJDK
     ifeq ($(PLATFORM), solaris)
Index: /trunk/openjdk/jdk/make/sun/cmm/kcms/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/cmm/kcms/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/cmm/kcms/Makefile	(revision 74)
@@ -33,5 +33,5 @@
 # Files
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 include FILES_c_windows.gmk
 else # PLATFORM
@@ -85,5 +85,5 @@
 vpath %.c   $(CLOSED_SRC)/share/native/$(PKGDIR)
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 
 OTHER_LDLIBS = user32.lib version.lib
Index: /trunk/openjdk/jdk/make/sun/dcpr/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/dcpr/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/dcpr/Makefile	(revision 74)
@@ -82,5 +82,5 @@
 vpath %.c   $(SHARE_SRC)/native/sun/java2d/pipe
 
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS = $(LIBM)
 endif # PLATFORM
Index: /trunk/openjdk/jdk/make/sun/font/FILES_c.gmk
===================================================================
--- /trunk/openjdk/jdk/make/sun/font/FILES_c.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/font/FILES_c.gmk	(revision 74)
@@ -113,5 +113,5 @@
 
 
-ifeq ($(PLATFORM),windows)
+ifeq ($(filter-out windows os2,$(PLATFORM)),)
 FILES_c_platform = fontpath.c
 FILES_cpp_platform = D3DTextRenderer.cpp
Index: /trunk/openjdk/jdk/make/sun/font/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/font/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/font/Makefile	(revision 74)
@@ -75,5 +75,5 @@
     sun/java2d/loops/GraphicsPrimitive.java
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 
   # Files built here do not compile with warning level 3 if warnings are fatal
@@ -131,5 +131,5 @@
 
 $(LIB_LOCATION)/$(LIB_PREFIX)freetype.$(LIBRARY_SUFFIX):
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 	$(CP) $(FREETYPE_LIB_PATH)/$(LIB_PREFIX)freetype.$(LIBRARY_SUFFIX) $@
 else 
@@ -169,5 +169,5 @@
 endif
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 vpath %.cpp   $(PLATFORM_SRC)/native/sun/windows
 vpath %.cpp   $(PLATFORM_SRC)/native/sun/java2d/d3d
@@ -205,5 +205,5 @@
 	    -I$(TEMPDIR)/../../sun.awt/awt/CClassHeaders
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 CPPFLAGS += -I$(PLATFORM_SRC)/native/sun/windows \
 	    -I$(PLATFORM_SRC)/native/sun/java2d/d3d
Index: /trunk/openjdk/jdk/make/sun/font/t2k/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/font/t2k/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/font/t2k/Makefile	(revision 74)
@@ -63,5 +63,5 @@
     sun/font/T2KFontScaler.java 
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 
   # Files built here do not compile with warning level 3 if warnings are fatal
@@ -99,5 +99,5 @@
 #
 # setup the list of libraries to link in...
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS  +=  $(LIBM) $(LIBCXX) -lfontmanager
   ifeq ($(PLATFORM), linux)
Index: /trunk/openjdk/jdk/make/sun/jawt/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/jawt/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/jawt/Makefile	(revision 74)
@@ -34,5 +34,5 @@
 # Files
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 FILES_cpp = jawt.cpp
 else # PLATFORM
@@ -50,5 +50,5 @@
 
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 #
 # Extra C flags.
@@ -142,5 +142,5 @@
 build: $(FILES_h)
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 include make.depend
 endif
Index: /trunk/openjdk/jdk/make/sun/jdbc/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/jdbc/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/jdbc/Makefile	(revision 74)
@@ -53,5 +53,5 @@
 # Use fake libraries on Solaris and Linux just so the library we create has
 #   a dependency on these two library names. (which are not part of the jdk)
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   # In jdk5 and jdk6, and on Solaris 32bit, we would have required that
   #    these two libraries exist at: $(ALT_ODBCDIR)/ISLIodbc/2.11/lib
@@ -83,5 +83,5 @@
 # The UNIX define specifies conditional compilation for UNIX
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   LDLIBS += odbc32.lib odbccp32.lib
 else
Index: /trunk/openjdk/jdk/make/sun/jdga/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/jdga/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/jdga/Makefile	(revision 74)
@@ -55,5 +55,5 @@
 vpath %.c   $(PLATFORM_SRC)/native/$(PKGDIR)
 
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   LDLIBS =  -ldga -lX11 -ldl -lc
 
Index: /trunk/openjdk/jdk/make/sun/net/FILES_java.gmk
===================================================================
--- /trunk/openjdk/jdk/make/sun/net/FILES_java.gmk	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/net/FILES_java.gmk	(revision 74)
@@ -122,5 +122,5 @@
 	sun/net/www/protocol/http/InMemoryCookieStore.java
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
     FILES_java += sun/net/www/protocol/http/NTLMAuthSequence.java 
 endif
Index: /trunk/openjdk/jdk/make/sun/nio/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/nio/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/nio/Makefile	(revision 74)
@@ -46,5 +46,5 @@
 
 # Exclude a few sources on windows
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   AUTO_JAVA_PRUNE = sun/nio/cs/ext/COMPOUND_TEXT.java         \
                     sun/nio/cs/ext/COMPOUND_TEXT_Decoder.java \
Index: /trunk/openjdk/jdk/make/sun/rmi/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/rmi/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/rmi/Makefile	(revision 74)
@@ -40,5 +40,5 @@
 
 SUBDIRS += rmi registry rmid
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
     SUBDIRS += cgi
 endif # PLATFORM
Index: /trunk/openjdk/jdk/make/sun/rmi/rmi/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/rmi/rmi/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/rmi/rmi/Makefile	(revision 74)
@@ -86,5 +86,5 @@
 	sun.rmi.transport.DGCImpl
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 build: stubs
 else # PLATFORM
Index: /trunk/openjdk/jdk/make/sun/security/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/Makefile	(revision 74)
@@ -39,5 +39,5 @@
 # build sun/security/jgss/wrapper on non-windows platform
 JGSS_WRAPPER =
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
     JGSS_WRAPPER = jgss/wrapper
 endif
@@ -48,5 +48,5 @@
 PKCS11 = pkcs11
 ifeq ($(ARCH_DATA_MODEL), 64)
-  ifeq ($(PLATFORM), windows)
+  ifeq ($(filter-out windows os2, $(PLATFORM)),)
     PKCS11 =
   endif
@@ -55,5 +55,5 @@
 # Build Microsoft CryptoAPI provider only on (non-64-bit) Windows platform.
 MSCAPI =
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   ifneq ($(ARCH_DATA_MODEL), 64)
     MSCAPI = mscapi
Index: /trunk/openjdk/jdk/make/sun/security/jgss/wrapper/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/jgss/wrapper/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/jgss/wrapper/Makefile	(revision 74)
@@ -72,5 +72,5 @@
 # Libraries to link
 #
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS = -ldl $(JVMLIB)
 endif
Index: /trunk/openjdk/jdk/make/sun/security/krb5/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/krb5/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/krb5/Makefile	(revision 74)
@@ -34,5 +34,5 @@
 AUTO_FILES_JAVA_DIRS = sun/security/krb5
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 #
 # Java files that define native methods
@@ -62,5 +62,5 @@
 # Rules
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   ifeq ($(JGSS_NATIVE_DIR_EXISTS), true)
     include $(BUILDDIR)/common/Library.gmk
@@ -73,5 +73,5 @@
 # Libraries to link
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS = $(JVMLIB)
 else
Index: /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile	(revision 74)
@@ -158,5 +158,5 @@
 # Libraries to link
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS += $(JVMLIB) Crypt32.Lib
 endif
Index: /trunk/openjdk/jdk/make/sun/security/pkcs11/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/pkcs11/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/pkcs11/Makefile	(revision 74)
@@ -156,5 +156,5 @@
 # Libraries to link
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS = $(JVMLIB)
 else
Index: /trunk/openjdk/jdk/make/sun/security/smartcardio/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/smartcardio/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/security/smartcardio/Makefile	(revision 74)
@@ -73,5 +73,5 @@
 # Libraries to link
 #
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
   OTHER_LDLIBS = $(JVMLIB) winscard.lib
 else
Index: /trunk/openjdk/jdk/make/sun/splashscreen/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/splashscreen/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/sun/splashscreen/Makefile	(revision 74)
@@ -62,5 +62,5 @@
 CFLAGS += -DSPLASHSCREEN
 
-ifneq ($(PLATFORM), windows)
+ifneq ($(filter-out windows os2, $(PLATFORM)),)
   CFLAGS += -DWITH_X11
   CPPFLAGS += -I$(OPENWIN_HOME)/include -I$(OPENWIN_HOME)/include/X11/extensions
Index: /trunk/openjdk/jdk/make/tools/reorder/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/tools/reorder/Makefile	(revision 73)
+++ /trunk/openjdk/jdk/make/tools/reorder/Makefile	(revision 74)
@@ -37,5 +37,5 @@
 PRELOAD_DIR = $(ABS_OUTPUTDIR)/reorder/$(ARCH)
 
-ifeq ($(PLATFORM), windows)
+ifeq ($(filter-out windows os2, $(PLATFORM)),)
 SEP = \\
 else