Index: trunk/bootcode/airboot.asm
===================================================================
--- trunk/bootcode/airboot.asm	(revision 75)
+++ trunk/bootcode/airboot.asm	(revision 76)
@@ -94,10 +94,4 @@
 ENDIF
 
-;
-; If ReleaseCode is not defined, it will produce debug-able code...
-; Rousseau: This is currently *not* functional so don't use it !
-;           It was used to debug AiR-BOOT as a .COM file.
-;
-ReleaseCode             equ     -1
 
 
@@ -133,21 +127,10 @@
 ; -----------------------------------------------------------------------------
 ; Address labels after code-move
-BootBaseSeg                 equ     08000h   ; Pre-boot, in the low 640K
-BootBasePtr                 equ         0h   ; We put our MBR to this location
+BootBaseSeg                 equ     08000h  ; Pre-boot, in the low 640K
+BootBasePtr                 equ         0h  ; We put our MBR to this location
 BootBaseExec                equ     BootBasePtr+offset MBR_RealStart
-StackSeg                    equ     07000h   ; Put the stack below the code
-
-; Use different addresses depending on whether in pre-boot
-; or debug (dos) environment.
-IFDEF ReleaseCode
-    StartBaseSeg    equ     00000h  ; Pre-boot, we are in low memory
-    StartBasePtr    equ     07C00h  ; BIOS starts our MBR at 0:7C00
-ELSE
-    ; Rousseau: where does this value come from ?
-    ; Should be CS.
-    ; Rectified in actual code by ignoring this value.
-    StartBaseSeg    equ     03A98h  ; Adjust to DOS segment
-    StartBasePtr    equ     00100h  ; We are a .COM file, DOS is active
-ENDIF
+StackSeg                    equ     07000h  ; Put the stack below the code
+StartBaseSeg                equ     00000h  ; Pre-boot, we are in low memory
+StartBasePtr                equ     07C00h  ; BIOS starts our MBR at 0:7C00
 
 
@@ -546,12 +529,6 @@
                 ;sti
 
-            ; Depending on pre-boot or debug.
-            ; Note that ReleaseCode is obsolete, so we will always move
-            ; 256 words; aka this sector, the MBR.
-            IFDEF ReleaseCode
+                ; Size of the MBR in words.
                 mov     cx, 256          ; Pre-boot environment
-            ELSE
-                mov     cx, 32700        ; Old Debug environment (move ~64kB)
-            ENDIF
 
                 ;
@@ -732,14 +709,4 @@
                 push    bx      ; Old SP
 
-
-            ; If we are in debug-mode, all code is moved already,
-            ; so we can directly jump to it.
-            ; One difference is that in debug-mode, the whole .com image is
-            ; loaded by dos while when air-boot is active from the MBR it
-            ; does the loading itself.
-            ; (This debug environment is obsolete and dis-fuctional)
-            IFNDEF ReleaseCode
-                jmp     AiR_BOOT_Start
-            ENDIF
 
                 ; Load the configuration-sectors from disk.
@@ -1428,15 +1395,4 @@
                 call    PASSWORD_AskChangeBootPwd
 
-            IFNDEF ReleaseCode
-                ; Debug Code to terminate DOS .COM program - used for
-                ;  testing AiR-BOOT
-                ; Obsolete.
-                int     3
-                mov     ax, 6200h
-                int     21h
-                mov     es, bx
-                mov     ax, 4C00h    ; Quit program
-                int     21h
-            ENDIF
                 call    ANTIVIR_SaveBackUpMBR
 
Index: trunk/bootcode/regular/other.asm
===================================================================
--- trunk/bootcode/regular/other.asm	(revision 75)
+++ trunk/bootcode/regular/other.asm	(revision 76)
@@ -348,8 +348,4 @@
     INT13X_Supported:
 
-    IFNDEF ReleaseCode
-        ret
-    ENDIF
-
 
         ;
Index: trunk/bootcode/regular/partmain.asm
===================================================================
--- trunk/bootcode/regular/partmain.asm	(revision 75)
+++ trunk/bootcode/regular/partmain.asm	(revision 76)
@@ -595,7 +595,5 @@
         call    PART_SearchFileSysHiddenID    ; Put on =STEALTH=
         mov     bptr es:[di+LocBRPT_SystemID], al
-    IFDEF ReleaseCode
-        call    DriveIO_SavePartition      ; Saves Partition-Table
-    ENDIF
+        call    DriveIO_SavePartition         ; Saves Partition-Table
         ret
 PART_HidePartition              EndP
@@ -1096,10 +1094,8 @@
 
 
-    IFDEF ReleaseCode
         ;
         ; Save configuration on HDD boots (save CFG_PartLast)
         ;
         call    DriveIO_SaveConfiguration
-    ENDIF
 
 
@@ -1201,10 +1197,8 @@
 
 
-    IFDEF ReleaseCode
         ;
         ; Save the Partition Table.
         ;
         call    DriveIO_SavePartition     ; Saves the Partition-Table    [SAVE]
-    ENDIF
 
 
@@ -1343,8 +1337,5 @@
         call    DriveIO_LoadPartition      ; Load Primary Partition Table
         call    PART_MarkFirstGoodPrimary
-
-    IFDEF ReleaseCode
         call    DriveIO_SavePartition       ; Saves the Partition-Table
-    ENDIF
 
 
@@ -2208,9 +2199,7 @@
         ; # JUMP TO THE PBR LOADER CODE #
         ; ###############################
-        IFDEF ReleaseCode
-            db      0EAh
-            dw      StartBasePtr
-            dw      StartBaseSeg
-        ENDIF
+        db      0EAh
+        dw      StartBasePtr
+        dw      StartBaseSeg
 
 
Index: trunk/bootcode/regular/partscan.asm
===================================================================
--- trunk/bootcode/regular/partscan.asm	(revision 75)
+++ trunk/bootcode/regular/partscan.asm	(revision 76)
@@ -222,9 +222,10 @@
 
         call    PARTSCAN_ScanPartition
-    IFDEF ReleaseCode
+
         call    DriveIO_SavePartition
-    ENDIF
+
         call    PARTSCAN_ScanPartitionForExtended
         jc      PSSDFP_LoadThisPartition
+
     PSSDFP_InvalidPartition:
         ret
@@ -304,5 +305,5 @@
         ; Clearing the boot-flags on other disks would prevent booting them
         ; from the BIOS. (TRAC ticket #6)
-        cmp     dl, 080h                            ; See if this is boot-disk 
+        cmp     dl, 080h                            ; See if this is boot-disk
         jne     PSSP_Skip_Clear_BootFlag            ; Nope, skip clear flag
         and     byte ptr [si+LocBRPT_Flags], 7Fh    ; Reset the Active-Flag
@@ -704,5 +705,5 @@
     PCCTP_CompareFailed:
         mov     ch, ah
-        ; Default Flags hinzufgen...
+        ; Insert Default Flags...
         mov     cl, LocIPT_DefaultFlags
 
Index: trunk/bootcode/setup/main.asm
===================================================================
--- trunk/bootcode/setup/main.asm	(revision 75)
+++ trunk/bootcode/setup/main.asm	(revision 76)
@@ -59,5 +59,5 @@
       or      ax, ax
       jz      SSTSI_NoItemPack
-      add     si, LocMENU_LenOfItemPack  ; ItemPack bergehen
+      add     si, LocMENU_LenOfItemPack  ; Add ItemPack size
      SSTSI_NoItemPack:
       add     si, LocMENU_LenOfMenuPtrBlock ; Skip Ptr-Block (+3 deshalb, weil danach INC!)
@@ -88,7 +88,5 @@
    mov     al, [SETUP_KeysOnEntry]
    test    al, Keys_Flags_EnterSetup
-IFDEF ReleaseCode
    jz      SCES_NoEnterSETUP
-ENDIF
   SCES_ForceEnter:
    call    SETUP_Main
@@ -672,5 +670,5 @@
 ENDIF
 
-; Zeichnet die Men Hilfe aufn Bildschirm
+; Display the Help Menu
 ;        In: SI - Pointer to 4 HelpStrings...
 ; Destroyed: None
@@ -1127,7 +1125,5 @@
    add     word ptr [CFG_LastTimeEditLow], 1
    adc     word ptr [CFG_LastTimeEditHi], 0         ; Update Time-Stamp
-   IFDEF ReleaseCode
-      call    DriveIO_SaveConfiguration
-   ENDIF
+   call    DriveIO_SaveConfiguration
    mov     byte ptr [SETUP_ExitEvent], 1            ; Exit and continue boot process
   SEMSAES_UserAbort:
@@ -1145,7 +1141,7 @@
 
   SEMEWS_DoThis:
-   IFDEF ReleaseCode                     ; Loads basic configuration...
-      call    DriveIO_LoadConfiguration  ; This is *NOT* IPT nor HideConfig
-   ENDIF
+   ; Loads basic configuration...
+   ; This is *NOT* IPT nor HideConfig
+   call    DriveIO_LoadConfiguration
    mov     byte ptr [SETUP_ExitEvent], 1            ; Exit and continue boot process
   SEMEWS_UserAbort:
Index: trunk/bootcode/setup/part_set.asm
===================================================================
--- trunk/bootcode/setup/part_set.asm	(revision 75)
+++ trunk/bootcode/setup/part_set.asm	(revision 76)
@@ -879,7 +879,7 @@
         mov     si, offset LVMSector
         call    LVM_UpdateSectorCRC
-        IFDEF ReleaseCode
-          call    DriveIO_SaveLVMSector      ; Save sector
-        ENDIF
+
+        call    DriveIO_SaveLVMSector      ; Save sector
+
         jmp     PSCPN_AllDone
 
@@ -892,7 +892,6 @@
           rep     movsb                      ; Copy IPT-name to Boot-Record
         pop     si
-        IFDEF ReleaseCode
-          call    DriveIO_SavePartition      ; Saves Boot-Record
-        ENDIF
+
+        call    DriveIO_SavePartition        ; Saves Boot-Record
 
     ; And reset VIBR-CRC, otherwise virus-warning and system-halt
@@ -1049,5 +1048,5 @@
    mov     cx, bx
    call    VideoIO_Locate
-   mov     al, 'µ'
+   mov     al, 0b5h
    call    VideoIO_PrintSingleChar
 
@@ -1081,5 +1080,5 @@
    mov     cx, CLR_PART_HIDE_WINDOW_BASE                     ; Lila on lila
    call    VideoIO_Color
-   mov     al, 'Æ'
+   mov     al, 0c6h
    call    VideoIO_PrintSingleChar
    ; --- Make Window-Footer - "State when booting..." at bottom right frame-line
@@ -1119,5 +1118,5 @@
 ;   inc     cl
 ;   call    MBR_Locate                    ; Location 16, HiddenX
-;   mov     al, 'µ'
+;   mov     al, 0b5h
 ;   call    MBR_PrintSingleChar
 ;   mov     cx, 0E05h                     ; Yellow on Lila
@@ -1134,5 +1133,5 @@
 ;   mov     cx, 0D05h                     ; Lila on lila
 ;   call    MBR_Color
-;   mov     al, 'Æ'
+;   mov     al, 0c6h
 ;   call    MBR_PrintSingleChar
 
@@ -1776,5 +1775,5 @@
       mov     cx, bx
       call    VideoIO_Locate
-      mov     al, 'µ'
+      mov     al, 0b5h
       call    VideoIO_PrintSingleChar
 
@@ -1808,5 +1807,5 @@
       mov     cx, CLR_PART_DL_WINDOW_BORDER2                 ; Lila on lila
       call    VideoIO_Color
-      mov     al, 'Æ'
+      mov     al, 0c6h
       call    VideoIO_PrintSingleChar
    pop     bx
Index: trunk/bootcode/special/lvm.asm
===================================================================
--- trunk/bootcode/special/lvm.asm	(revision 75)
+++ trunk/bootcode/special/lvm.asm	(revision 76)
@@ -501,7 +501,6 @@
         call    LVM_RemoveVolLetterFromSector
 
-    IFDEF ReleaseCode
         call    DriveIO_SaveLVMSector   ; Save sector
-    ENDIF
+
     LVMDLR_NextPartition:
         inc     bx
@@ -531,7 +530,5 @@
         call    LVM_UpdateSectorCRC           ; Update LVM-CRC now
 
-    IFDEF ReleaseCode
-        call    DriveIO_SaveLVMSector      ; Save sector
-    ENDIF
+        call    DriveIO_SaveLVMSector         ; Save sector
 
     LVMDLR_DestPartNotFound:
Index: trunk/bootcode/special/virus.asm
===================================================================
--- trunk/bootcode/special/virus.asm	(revision 75)
+++ trunk/bootcode/special/virus.asm	(revision 76)
@@ -51,7 +51,7 @@
    mov     si, 1Ch*4
    rep     movsw                         ; INT 1C Ptr
-   IFDEF ReleaseCode
-      call    DriveIO_SaveConfiguration
-   ENDIF
+
+   call    DriveIO_SaveConfiguration
+
    jmp     VCFS_Finished
 