Index: psi/trunk/os2/WarpIN/create_packages.cmd
===================================================================
--- psi/trunk/os2/WarpIN/create_packages.cmd	(revision 77)
+++ psi/trunk/os2/WarpIN/create_packages.cmd	(revision 77)
@@ -0,0 +1,48 @@
+/* REXX */
+
+/*
+ *  Base name of all archives
+ */
+ARCHIVE = 'psios2-0_10_1-os2'
+
+/*
+ *  Base name of the installation script
+ */
+SCRIPT  = 'psi'
+
+/*
+ *  Name of the Psi package (used as a name of the directory containing
+ *  all package files and as a name of the target WPI archive)
+ */
+PACKAGE_PSI = 'psios2-0_10_1-os2'
+
+/*
+ *  Name of the LIBC package (used as a name of the directory containing
+ *  all package files and as a name of the target WPI archive)
+ */
+PACKAGE_LIBC = 'libc-0_6_1-csd1'
+
+
+call warpin_env.cmd
+ 
+'del 'ARCHIVE'.exe 'ARCHIVE'.wpi 'ARCHIVE'.zip > nul 2>&1'
+
+/* ZIP -- Psi Only */
+'zip.exe 'ARCHIVE' -9rS',
+          ARCHIVE'.zip',
+          PACKAGE_PSI '> 'ARCHIVE'.zip.log 2>&1'
+
+/* WPI -- Psi Only */
+'wic.exe 'ARCHIVE' -a',
+         '1 -c.\'PACKAGE_PSI' -r *',
+         '-s 'SCRIPT'.wis > 'ARCHIVE'.wpi.log 2>&1'
+
+/* EXE -- Full install */
+
+'wic.exe 'ARCHIVE' -a -U',
+         '1 -c.\'PACKAGE_PSI' -r *',
+         '2 -c.\'PACKAGE_LIBC' -r *',
+         '-s 'SCRIPT'_full.wis > 'ARCHIVE'.exe.log 2>&1'
+
+
+exit
Index: psi/trunk/os2/WarpIN/create_psi_packages.cmd
===================================================================
--- psi/trunk/os2/WarpIN/create_psi_packages.cmd	(revision 76)
+++ 	(revision )
@@ -1,57 +1,0 @@
-/*  
-    create_psi_packages.cmd:
-
-    This script will create the PSI packages for distribution.
-    *.wpi
-    *.exe
-    *.zip
-
-    (c) 2006 - Juergen Ulbts
-*/
-call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
-call SysLoadFuncs
-
-CURRENT_DIR = DIRECTORY()
-
-/* ========================================================= */
-/*  Application specific information - NEEDS MODIFICATION    */
-/* ========================================================= */
-ARCHIVE_NAME='psi_0-10-os2-b1'               /* Target archive name without extension */
-WARPIN_SCRIPT_NAME='psi_0-10-0-2.wis'        /* WarpIN *.wis script name  */
-BINARY_DIRECTORY='psi_0-10-os2-b1'           /* Subdirectory of version where the build application can be found */
-
-
-/* ========================================================= */
-/*  Set the package creation application and settings        */
-/* ========================================================= */
-WARPIN_CREATOR='wic.exe'                     /* WarpIN application the create WarpIN achives */
-ARCHIVE_CREATOR='zip.exe'                    /* Packer */
-ARCHIVE_CREATOR_PARAMETER='-9rS'             /* Packer parameters */       
-
-
-/* ========================================================= */
-/*  Search for wic.exe and call warpin_env.cmd if not found  */
-/* ========================================================= */
-if (SysSearchPath('PATH', WARPIN_CREATOR) == '') then do
-    call 'warpin_env.cmd'
-end
- 
-/* ========================================================= */
-/*  Delete old package with the same name as 'ARCHIVE_NAME'  */
-/* ========================================================= */
-'del .\Build_Packages\'||ARCHIVE_NAME||'.* > NUL'
-
-/* ========================================================= */
-/*  Create WarpIN packages                                   */
-/* ========================================================= */
-''||WARPIN_CREATOR||' .\Build_Packages\'||ARCHIVE_NAME||'.wpi -a 1 -c.\Version\'||BINARY_DIRECTORY||' -r * -s ".\Scripts\'||WARPIN_SCRIPT_NAME||'" > .\Build_Packages\'||ARCHIVE_NAME||'.wpi_log 2>&1'
-''||WARPIN_CREATOR||' .\Build_Packages\'||ARCHIVE_NAME||'.exe -a 1 -c.\Version\'||BINARY_DIRECTORY||' -U -r * -s ".\Scripts\'||WARPIN_SCRIPT_NAME||'" > .\Build_Packages\'||ARCHIVE_NAME||'.exe_log 2>&1'
-
-/* ========================================================= */
-/*  Create ZIP archive                                       */
-/* ========================================================= */
-'cd Version'
-''||ARCHIVE_CREATOR||' '||ARCHIVE_CREATOR_PARAMETER||' ..\Build_Packages\'||ARCHIVE_NAME||'.zip .\'||BINARY_DIRECTORY
-CALL DIRECTORY CURRENT_DIR
-
-exit;
Index: psi/trunk/os2/WarpIN/psi.wis
===================================================================
--- psi/trunk/os2/WarpIN/psi.wis	(revision 77)
+++ psi/trunk/os2/WarpIN/psi.wis	(revision 77)
@@ -0,0 +1,545 @@
+<!--@archive:psios2-0_10_1-os2:-->
+
+<WARPIN VERSION="0.9.5"
+		OS="OS2_3x">
+
+<HEAD>
+
+<TITLE>Psi/2 0.10.1 (2006-09-26)</TITLE>
+
+
+<PCK INDEX=1
+     PACKAGEID="netlabs.org\Psi/2\Psi/2 0.10.1\0\10\1\0"
+     TARGET="$(WARPIN_DEFAULTAPPSPATH)\psios2-0_10_1" BASE
+     TITLE="Psi/2 0.10.1"
+
+     NODESELECT
+     REQUIRES="netlabs.org\kLIBC\LIBC 0.6 Runtime\0\6\1"
+
+     KILLPROCESS="psi.exe"
+
+     LONGFILENAMES
+
+     CREATEOBJECT="REPLACE WPFolder|Psi/2 0.10.1|<WP_DESKTOP>|OBJECTID=<psios2-0_10_1-Folder>;"
+     CREATEOBJECT="REPLACE WPProgram|Psi/2 0.10.1|<psios2-0_10_1-Folder>|EXENAME=$(1)\Psi.exe;STARTUPDIR=$(1);ICONFILE=$(1)\Psi.ico;"
+     CREATEOBJECT="REPLACE WPShadow|Readme.txt|<psios2-0_10_1-Folder>|SHADOWID=$(1)\Readme.txt;"
+     CREATEOBJECT="REPLACE WPShadow|Readme-OS2.txt|<psios2-0_10_1-Folder>|SHADOWID=$(1)\Readme-OS2.txt;"
+     CREATEOBJECT="REPLACE WPShadow|Changes.txt|<psios2-0_10_1-Folder>|SHADOWID=$(1)\Changes.txt;"
+
+     CREATEOBJECT="REPLACE WPFolder|Additional Links|<psios2-0_10_1-Folder>|OBJECTID=<psios2-0_10_1-Links>;"
+     CREATEOBJECT="REPLACE WPUrl|Psi/2 HomePage|<psios2-0_10_1-Links>|NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://svn.netlabs.org/qtapps/wiki/Psi/;"
+     CREATEOBJECT="REPLACE WPUrl|Psi/2 Downloads|<psios2-0_10_1-Links>|NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=ftp://ftp.netlabs.org/pub/qtapps/psi/;"
+     CREATEOBJECT="REPLACE WPUrl|Qt3 for OS/2 HomePage|<psios2-0_10_1-Links>|NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://svn.netlabs.org/qt3/;"
+     CREATEOBJECT="REPLACE WPUrl|Psi Official HomePage|<psios2-0_10_1-Links>|NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://psi-im.org/;"
+     CREATEOBJECT="REPLACE WPUrl|Psi Official Wiki|<psios2-0_10_1-Links>|NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://psi-im.org/wiki/Main_Page;"
+
+>Base package containing the Psi application. This package is required</PCK>
+
+<REXX NAME="GetDLLPath">
+    rc = rxFuncAdd('SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs')
+    rc = SysLoadFuncs()
+    result = '?:\OS2\DLL'
+    bestPath = WirexxGetEnv('WARPIN_DEFAULTAPPSPATH')'\DLL';
+    config_sys = SysBootDrive()'\config.sys'
+    do while lines(config_sys)
+        line = linein(config_sys)
+        if (left(line, 8) == 'LIBPATH=') then do
+            /* locate the previous occurence of path */
+            libpath = translate(substr(line, 9))
+            path = translate(bestPath)
+            l = length(path)
+            found = 0; p = 1
+            do while (\found)
+                p = pos(path, libpath, p)
+                if (p == 0) then leave
+                cb = ''; ca = ''
+                /*<*/
+                if (p > 1) then cb = substr(libpath, p - 1, 1)
+                if (p + l <= length(libpath)) then ca = substr(libpath, p + l, 1)
+                /*>*/
+                found = (cb == '' | cb == ';') & (ca == '' | ca == ';')
+                if (\found) then p = p + 1
+            end
+            if (found) then do
+                result = bestPath
+                leave
+            end
+        end
+    end
+    return result
+</REXX>
+
+<!--PCK INDEX=2
+     PACKAGEID="netlabs.org\kLIBC\LIBC 0.6 Runtime\0\6\1\0"
+     TITLE="LIBC 0.6 Runtime"
+     TARGET="=("GetDLLPath")"
+     FIXED NODESELECT
+>kLIBC 0.6 Runtime Libraries. This package is required for Psi</PCK-->
+
+</HEAD>
+<BODY>
+
+
+<PAGE INDEX=1 TYPE=README>
+<NEXTBUTTON TARGET=2>~Next</NEXTBUTTON>
+<TEXT>Welcome to the Psi/2 Installation Program!
+
+Please read through the following pages by pressing "Next" to continue or press "Cancel" to abort the installation.</TEXT>
+<README FORMAT=HTML>
+<b>What is Psi</b>
+<p>
+Psi is a capable Jabber client aimed at experienced users.  Its design
+goals are simplicity and stability.  Psi is highly portable and runs on
+Windows, OS/2, Unix/X11, and MacOS X.
+</p>
+<p>
+The interface is very ICQ-like.  Alerts appear in the contact list when
+events are received, and things like subscriptions requests appear as
+<i>system messages</i> (ICQ users know these well).  Even <i>Chats</i> are
+queued in the contact list.  Also, chats are <i>remembered</i> by default,
+so that you don't have to keep a bunch of windows open for each person.
+Just close the chat window.  If you open it again it will all be there.
+</p>
+<p>
+Psi is minimal but powerful.  There are keybindings for just about
+everything, Unicode is supported throughout, and contacts are cached
+offline.  Security is also a major consideration, and Psi provides it for
+both client-to-server (SSL) and client-to-client (GnuPG).
+</p>
+<p>
+This program is licensed under the GNU General Public License.  See
+the <code>COPYING</code> file inlcuded in this package for more information.
+</p>
+<p>
+You can find more information about Psi on the official Psi home page
+at <code>http://psi-im.org</code>.
+</p>
+</p>
+<p>
+<b>What is Psi/2</b>
+</p>
+<p>
+Psi/2 is a separate development branch of Psi initially created to work on
+a version of Psi for OS/2 and eComStation operating systems.  Why a separate
+branch?  In ealy 2006, original Psi authors decided to discontinue the support
+of the Qt Toolkit Version 3 and ported Psi sources to Qt Version 4.  Psi 0.10
+was the last release based on Qt Version 3.  However, Qt Version 4 is not (yet)
+available for the OS/2 platform, therefore the sources of Psi 0.10 have been
+taken and ported to OS/2.
+</p>
+<p>
+In the process of porting, several minor Psi bugs were fixed and some few
+bits of new functionality were added.  These changes are unlikely to be applied
+to the current official Psi sources because of the differences in Qt Toolkits
+and because original authors are not interested in supporting the Qt 3 branch.
+</p>
+<p>
+There are some more improvements planned to the Psi/2 branch.  This branch will
+exist until at least Qt Version 4 for OS/2 becomes available.  Please note that
+Psi/2 is NOT supported by original Psi developers, so don't send them bug
+reports and feature requests.  See below for information about reporting bugs.
+</p>
+<p>
+In order to clearly distinguish the original Psi application from Psi/2,
+the latter is used as the application name for the Psi/2 branch (including
+the 'Jabber client name and version' string reported to Jabber servers).
+In situations where using the slash character makes problems or even imposible
+(such as file names of distribution archives), 'psios2' is used instead.
+</p>
+<p>
+Currently, binary Psi/2 packages are distributed only for OS/2 and eComStation
+(a Windows package based on Qt 3 is planned soon).  If you need a version of Psi
+for a different platform, please visit the official Psi home hage mentioned
+above.  There you will find the most recent version of Psi based on the Qt
+Toolkit Version 4.
+</p>
+<p>
+The Psi/2 home page is located at <code>http://svn.netlabs.org/qtapps/wiki/Psi</code>.
+</p>
+<p>
+Binary Psi/2 packages can be found at <code>ftp://ftp.netlabs.org/pub/qtapps/psi</code>.
+</p>
+</README>
+</PAGE>
+
+
+<PAGE INDEX=2 TYPE=README>
+<NEXTBUTTON TARGET=3>~I agree</NEXTBUTTON>
+<TEXT>Please read the Psi License information. By pressing the "I agree" button, you agree to all terms and conditions to the below license agreement.</TEXT>
+<README FORMAT=HTML>
+  As a special exception, the copyright holder(s) give permission to link
+  this program with the Qt Library (commercial or non-commercial edition),
+  and distribute the resulting executable, without including the source
+  code for the Qt library in the source distribution.
+<p>
+  As a special exception, the copyright holder(s) give permission to link
+  this program with any other library, and distribute the resulting
+  executable, without including the source code for the library in the
+  source distribution, provided that the library interfaces with this
+  program only via the following plugin interfaces:
+</p>
+<p>
+<ol>
+<li>
+    The Qt Plugin APIs, only as authored by Trolltech
+<li>
+    The QCA Plugin API, only as authored by Justin Karneges
+</ol>
+<p><br>
+		    <b>GNU GENERAL PUBLIC LICENSE</b>
+		       <b>Version 2, June 1991</b>
+</p>
+<p>
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.<br>
+                          675 Mass Ave, Cambridge, MA 02139, USA
+</p>
+<p>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+</p>
+<p>
+			    <b>Preamble</b>
+</p>
+<p>
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software -- to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Library General Public License instead.)  You can apply it to
+your programs, too.
+</p>
+<p>
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+</p>
+<p>
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+</p>
+<p>
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+</p>
+<p>
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+</p>
+<p>
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+</p>
+<p>
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+</p>
+<p>
+  The precise terms and conditions for copying, distribution and
+modification follow.
+</p>
+<p>
+		    <b>GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION</b>
+</p>
+<p>
+  <b>0.</b> This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The <i>Program</i>, below,
+refers to any such program or work, and a <i>work based on the Program</i>
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term <i>modification</i>.)  Each licensee is addressed as <i>you</i>.
+</p>
+<p>
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+</p>
+<p>
+  <b>1.</b> You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+</p>
+<p>
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+</p>
+<p>
+  <b>2.</b> You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+</p>
+<p>
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+</p>
+<p>
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+</p>
+<p>
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+</p>
+<p>
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+</p>
+<p>
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+</p>
+<p>
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+</p>
+<p>
+  <b>3.</b> You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+</p>
+<p>
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+</p>
+<p>
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+</p>
+<p>
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+</p>
+<p>
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+</p>
+<p>
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+</p>
+<p>
+  <b>4.</b> You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+</p>
+<p>
+  <b>5.</b> You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+</p>
+<p>
+  <b>6.</b> Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+</p>
+<p>
+  <b>7.</b> If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+</p>
+<p>
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+</p>
+<p>
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+</p>
+<p>
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+</p>
+<p>
+  <b>8.</b> If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+</p>
+<p>
+  <b>9.</b> The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+</p>
+<p>
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and <i>any
+later version</i>, you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+</p>
+<p>
+  <b>10.</b> If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+</p>
+<p>
+			    <b>NO WARRANTY</b>
+</p>
+<p>
+  <b>11.</b> BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM <i>AS IS</i> WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+</p>
+<p>
+  <b>12.</b> IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+</p>
+<p>
+		     <b>END OF TERMS AND CONDITIONS</b>
+</p>
+</README>
+</PAGE>
+
+
+<PAGE INDEX=3 TYPE=README>
+<NEXTBUTTON TARGET=4>~Next</NEXTBUTTON>
+<TEXT>Below is the list of changes in this version of Psi/2. Please read it before installing and press "Next" to continue.</TEXT>
+<README EXTRACTFROMPCK=1 FORMAT=PLAIN>Changes.txt</README>
+</PAGE>
+
+
+<PAGE INDEX=4 TYPE=CONTAINER>
+<NEXTBUTTON TARGET=5>~Next</NEXTBUTTON>
+<TEXT>Please select the packages which are to be installed. You may change the target path for the Psi package, but please don't specify a path containing an existing installation of Psi.</TEXT>
+</PAGE>
+
+
+<PAGE INDEX=5 TYPE=CONFIGURE>
+<NEXTBUTTON TARGET=6>~Next</NEXTBUTTON>
+<TEXT>Please select additional configuration that WarpIN should perform after installing this archive.</TEXT>
+</PAGE>
+
+
+<PAGE INDEX=6 TYPE=TEXT>
+<NEXTBUTTON TARGET=0>I~nstall</NEXTBUTTON>
+<TEXT>Press "Install" to begin installing the Psi Jabber Client.</TEXT>
+</PAGE>
+
+
+</BODY>
+</WARPIN>